#ifndef LIBREGEXIS024_MISC_FA_FUNCS_H
#define LIBREGEXIS024_MISC_FA_FUNCS_H

#include "finite_automaton.h"
#include "fa_first_stage_fix.h"

namespace regexis024 {
    FA_Node* copy_fa_node(FA_Node& node, FA_Container& fa);
    void yay_new_start(FA_Container& fa, FA_NodePathPart* node);
    void reattach_fa_node_edge(FA_Node** old_node_ptr, FA_Node* new_node);
    void add_option_to_fork_node(FA_NodeOfForking* fnode, FA_Node* transition_dest);
    void reattach_nxt_node(FA_NodePathPart* node, FA_Node* dest);

    /* This is a one weird operation. New node in resultFa will still point to nodes in sourceFa,
    * without increasing refcount of those nodes. YOU HAVE TO FIX IT ASAP */
    FA_Node* copy_fa_node_to_another_fa(FA_Node& node, FA_Container& resultFa);
}

#endif //LIBREGEXIS024_MISC_FA_FUNCS_H
