#ifndef PART_OF_EXPR_THAT_TRACKS_H
#define PART_OF_EXPR_THAT_TRACKS_H

#include <map>
#include <vector>
#include <string>
#include <libregexis024fa/tracking_variables.h>

namespace regexis024 {
    struct SubtrackingNameUsageInfo: public TrackingVariableInfo{
        bool discovered = false;
        bool used_in_sifting = false;
        bool minimizing = false;
    };

    struct KnownTrackingTools {
        std::map<std::string, int64_t> track_names;
        std::vector<SubtrackingNameUsageInfo> retrieval_info;
    };
}

#endif //PART_OF_EXPR_THAT_TRACKS_H
